<?php
namespace FM\Service;

use FM\Factory\Fm00005000VistoriasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\Remote\FileUploader\Server;
use Zeedhi\Framework\Remote\cURLRequest;
use FM\Service\FuncionariosHierarqService;

class Fm00005000VistoriasService {

    protected $connection;
    protected $Fm00005000VistoriasFactory;
    protected $FuncionariosHierarqService;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, Fm00005000VistoriasFactory $Fm00005000VistoriasFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $Environment, NewCode $newCode) {
        $this->connection                   = $entityManager->getConnection();
        $this->Fm00005000VistoriasFactory   = $Fm00005000VistoriasFactory;
        $this->FuncionariosHierarqService   = $FuncionariosHierarqService;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }
    
    // Busca as Vistorias do Grid
    public function getVistorias() {
        $cdoperador = $this->Environment->getCdOperador();
        $listaOperadores = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdoperador);
        return $this->Fm00005000VistoriasFactory->getVistorias($listaOperadores);
    }

    // Buscar informaçãos para mondar o TreeTekGrid
    public function getCriteriosGrid($parametro) {
        $params = array(
            'NRGERENCIAMENTOCHK' => $parametro['NRGERENCIAMENTOCHK']
        );
        return $this->Fm00005000VistoriasFactory->getCriteriosGrid($params);
    }

    // Edita a vistoria
    public function updateInspection($param) {
        $this->connection->beginTransaction();
        try {
            $nrorg =  $this->Environment->getNrOrg();
            $operador = $this->Environment->getCdOperador();
            if(!$param['finalizar']){
                forEach($param["DRG"] as $parametro) {
                    
                    $salvaCriterio = array(
                        "IDMARCADO"             => $parametro['IDMARCADO'],
                        "NRCRITERIOTARGERCHK"   => $parametro['NR'],
                        "CDOPERULTATU"          => $operador,
                        "NRORGULTATU"           => $nrorg,
                        "NRGERENCIAMENTOCHK"    => $parametro['NRGERENCIAMENTOCHK']
                       
                    );
                   
                    $this->Fm00005000VistoriasFactory->salvarCriterios($salvaCriterio);
                }
            } else {
               $salvaVistoria = array(
                    'DSOBSTAREFAGERCHK' => $param['DRG'],
                    'NRGERENCIAMENTOCHK' => $param['NR'],
                    "CDOPERULTATU"          => $operador,
                    "NRORGULTATU"           => $nrorg
               );

               $this->Fm00005000VistoriasFactory->salvarObservacao($salvaVistoria);

               $finalizaVistoria = array(
                'NRGERENCIAMENTOCHK'    => $param['NR'],
                "CDOPERULTATU"          => $operador,
                "NRORGULTATU"           => $nrorg
                );
                
                $this->Fm00005000VistoriasFactory->finalizarVistoria($finalizaVistoria);
            }

            $this->connection->commit();
        } catch(\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}
