<?php
namespace FM\Service;

use FM\Factory\Fm00031000TarefasVistoriasContratoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;

class Fm00031000TarefasVistoriasContratoService { 

    protected $TarefasVistoriasContratoFactory;
    protected $FindService;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, Fm00031000TarefasVistoriasContratoFactory $TarefasVistoriasContratoFactory, Environment $Environment, NewCode $newCode) {
        $this->connection                       = $entityManager->getConnection();
        $this->TarefasVistoriasContratoFactory  = $TarefasVistoriasContratoFactory;
        $this->Environment                      = $Environment;
        $this->newCode                          = $newCode;
    }

    // FUNÇÕES DA TAB DE TAREFAS
    public function getContratosTarefas() {
        return $this->TarefasVistoriasContratoFactory->getContratosTarefas();
    }

    public function getItensTarefasContratos($parametros) {
        return $this->TarefasVistoriasContratoFactory->getItensTarefasContratos(array(
            "CDSERVORCA"        => $parametros['CDSERVORCA'],
            "CDTPMEDIDASERV"    => $parametros['CDTPMEDIDASERV']
        ));
    }

    public function getContratosVistoria() {
        return $this->TarefasVistoriasContratoFactory->getContratosVistoria();
    }

    public function getItensVistoriaContrato($parametros) {
        return $this->TarefasVistoriasContratoFactory->getItensVistoriaContrato(array(
            "CDSERVORCA"        => $parametros['CDSERVORCA'],
            "CDTPMEDIDASERV"    => $parametros['CDTPMEDIDASERV']
        ));
    }

}

