/* eslint-disable */
import { Utilities } from '@/util/Utilities';
import {
    CheckboxMultiple, Date as ZdDate, DialogService, Form, LoadingService, Modal, ModalService,
    Select, SelectMultiple, TextInput, Text, Time,
} from '@zeedhi/common';
import { Http, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Fm00030000TarefasRecorrentesController {
    private cadastroTarefa!: Modal;

    private modalCriterio!: Modal;

    private modalPlayTarefa!: Modal;

    private modalPauseTarefa!: Modal;

    private modalEdicaoTarefa!: Modal;

    private cancelamentoTarefas!: Modal;

    public controlePlayPause!: boolean;

    public botaoPlayPause!: boolean;

    private clicks = 0;

    public linhaClicada: any;

    /* ---------- Controle dos modais ---------- */
    public async addNewRow() {
        this.cadastroTarefa = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_001_modal_cadastro_tarefas_recorrentes' });
        this.cadastroTarefa.show();
    }

    public async fecharModalTarefas() {
        this.cadastroTarefa.hide();
        this.cadastroTarefa?.destroy();
    }

    public async exibirModalCriterios() {
        this.modalCriterio = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_002_modal_cadastro_criterios' });
        this.modalCriterio.show();
    }

    public async fecharModalCriterio() {
        this.modalCriterio.hide();
        this.modalCriterio?.destroy();
    }

    public async exibirModalCancelamento() {
        this.cancelamentoTarefas = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_006_modal_cancelar_tarefas' });
        this.cancelamentoTarefas.show();
    }

    public async fecharModalCancelamento() {
        this.cancelamentoTarefas.hide();
        this.cancelamentoTarefas?.destroy();
    }

    public async modalPlayPause(row: any) {
        if (row.NMIDSITUACAO === 'Pausada') {
            this.modalPlayTarefa = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_003_modal_play_tarefas' });
            this.modalPlayTarefa.show();
        } else if (row.NMIDSITUACAO === 'Em Andamento') {
            this.modalPauseTarefa = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_004_modal_pause_tarefas' });
            this.modalPauseTarefa.show();
        }
    }

    public async fecharModalPause() {
        this.modalPauseTarefa.hide();
        this.modalPauseTarefa?.destroy();
    }

    public async fecharModalPlay() {
        this.modalPlayTarefa.hide();
        this.modalPlayTarefa?.destroy();
    }

    public async exibirModalEdicao() {
        this.modalEdicaoTarefa = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_005_modal_editar_tarefas' });
        this.modalEdicaoTarefa.show();
        setTimeout(() => {
            this.setInfo(this.linhaClicada);
        }, 500);
    }

    public setInfo(row: any) {
        Metadata.getInstance<Text>('nomeTarefa').text = row.NMTAREFA;
        Metadata.getInstance<Text>('nomeLocal').text = row.NMLOCALCLIENTE;
        Metadata.getInstance<Text>('situacaoTarefa').text = row.NMIDSITUACAO;
        Metadata.getInstance<Time>('selectHoraInicio1').value = row.HORARIO;
        Metadata.getInstance<TextInput>('selectTempoMedio1').value = row.DURACAO;
        Metadata.getInstance<SelectMultiple>('selectDiaSemana').setValue(row.DIASSEMANA.split(','));
        Metadata.getInstance<Select>('selectFuncionario').setValue(row.CDOPERTAREFA);
        Metadata.getInstance<Select>('selectEncarregado').setValue(row.CDOPERVISTORIA);
    }

    public async fecharModalEdicao() {
        this.modalEdicaoTarefa.hide();
        this.modalEdicaoTarefa?.destroy();
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(`formTarefas_${component.name}`);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    // ========== Controles dos Selects ===================
    public changeTipoDeLocal() {
        const cliente = Metadata.getInstance<Select>('CDCLIENTE');
        const tipoLocal = Metadata.getInstance<Select>('NRTIPOLOCALCLI');
        if (cliente.value) {
            tipoLocal.disabled = false;
        } else {
            tipoLocal.disabled = true;
        }
    }

    public changeLocal() {
        const tipoLocal = Metadata.getInstance<Select>('NRTIPOLOCALCLI');
        const local = Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        if (tipoLocal.value.length > 0) {
            local.disabled = false;
            checklist.disabled = false;
            local.datasource.setFilter({
                NRTIPOLOCALCLI: tipoLocal.value,
            });
            checklist.datasource.setFilter({
                NRTIPOLOCALCLI: tipoLocal.value,
            });
        } else {
            local.setValue([]);
            local.disabled = true;
            checklist.setValue(null);
            checklist.disabled = true;
        }
    }

    public changeItensChecklist() {
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        const itenschecklist = Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK');
        if (checklist.value) {
            itenschecklist.disabled = false;
            itenschecklist.datasource.setFilter({
                NRCHECKLIST: checklist.value,
            });
        } else {
            itenschecklist.setValue([]);
            itenschecklist.disabled = true;
        }
    }

    public changeEscopo() {
        const itenschecklist = Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI');
        const escopo = Metadata.getInstance<Select>('NRESCOPOSTAREFA');
        if (itenschecklist.value.length > 0) {
            escopo.disabled = false;
        } else {
            escopo.setValue([]);
            escopo.disabled = true;
        }
    }

    public changeTarefa() {
        const escopo = Metadata.getInstance<SelectMultiple>('NRESCOPOSTAREFA');
        const tarefa = Metadata.getInstance<SelectMultiple>('NRTAREFACHK');
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        if (escopo.value.length > 0) {
            tarefa.disabled = false;
            tarefa.datasource.setFilter({
                NRATIVIDADECHK: itenschecklist.value,
            });
        } else {
            tarefa.setValue([]);
            tarefa.disabled = true;
        }
    }

    public changeContratos({ component }: any) {
        const selectContratos = Metadata.getInstance<SelectMultiple>('NRSEQCONTRATO');

        if (component.value.length > 0) {
            selectContratos.disabled = false;
            const { selectValue } = component;

            selectContratos.datasource.setFilter({
                NRESTRUTURAM: selectValue.map((item: any) => item.NRESTRUTURAM),
            });
        } else if (component.value.length < 1) {
            selectContratos.disabled = true;
        }
    }

    public setCriterios() {
        const tarefa = Metadata.getInstance<SelectMultiple>('NRTAREFACHK');
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        const checkbox = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        if (tarefa.value.length > 0) {
            checkbox.datasource?.setFilter({
                NRTAREFACHK: tarefa.value,
                NRATIVIDADECHK: itenschecklist.value,
                NRCHECKLIST: checklist.value,
            });
            checkbox.datasource?.get();
            checkbox.isVisible = true;
        } else {
            tarefa.setValue([]);
            checkbox.isVisible = false;
        }
    }

    public novoCriterio() {
        const chk = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        const valor = Metadata.getInstance<TextInput>('inputNovoCriterio').value;
        chk!.datasource!.data!.push({
            NRCRITERIOTAREFACHK: valor,
            DSCRITERIOTAREFA: valor,
        });
        chk!.value.push(valor);
        this.fecharModalCriterio();
    }

    public validaVistoria() {
        const vistoria = Metadata.getInstance<Select>('selectCriarVistoria');
        const observacao = Metadata.getInstance<Select>('selectObservacoesObrigatorias');
        if (vistoria.value === 1) {
            observacao!.datasource!.data!.push({
                value: '3',
                text: 'Somente na vistoria',
            });
            observacao!.datasource!.data!.push({
                value: '4',
                text: 'Na tarefa e na vistoria',
            });
        } else {
            observacao.datasource?.get();
        }
    }

    public validaDiaPeriodo(data: any, data2: any, dias: any) {
        for (let dataAux = data; data <= data2; dataAux.setDate(dataAux.getDate() + 1)) {
            if (dias.includes(String(dataAux.getDay()))) {
                return true;
            }
        }
        return false;
    }

    /* ========== Requisições ========== */
    public inserirTarefa() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        const checkBoxMultiple = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        const formTarefas = Metadata.getInstance<Form>('formCadastroTarefas').validate();
        const formCriterios = Metadata.getInstance<Form>('formTarefas_dropBoxCriterioAvaliacao').validate();
        const formAgendamento = Metadata.getInstance<Form>('formTarefas_dropBoxDadosAgendamento').validate();
        if (formTarefas && formCriterios && formAgendamento) {
            const dados = [{
                HORAINICIO: Metadata.getInstance<Time>('selectHoraInicio').value,
                DURACAO: Metadata.getInstance<TextInput>('selectdDuracao').value,
                FUNCIONARIO: Metadata.getInstance<Select>('selectFuncionario').value,
                ENCARREGADO: Metadata.getInstance<Select>('selectEncarregado').value,
            }];

            LoadingService.show();
            Http.post('/insertTarefasRecorrentes', {
                NOMETAREFA: Metadata.getInstance<TextInput>('nomeTarefa').value,
                CDCLIENTE: Metadata.getInstance<Select>('CDCLIENTE').value,
                NRTIPOLOCALCLI: Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI').value,
                NRLOCALCLIENTE: Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE').value,
                NRCHECKLIST: Metadata.getInstance<Select>('NRCHECKLIST').value,
                NRATIVIDADECHK: Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK').value,
                NRESCOPOSTAREFA: Metadata.getInstance<SelectMultiple>('NRESCOPOSTAREFA').value,
                NRTAREFACHK: Metadata.getInstance<SelectMultiple>('NRTAREFACHK').value,
                NRCRITERIOTAREFACHK: checkBoxMultiple.datasource?.data.filter((box: any) => checkBoxMultiple.value.indexOf(box.NRCRITERIOTAREFACHK) >= 0),
                DATERANGE: [Metadata.getInstance<ZdDate>('selectDataDe').value],
                DIASEMANA: Metadata.getInstance<SelectMultiple>('selectDiaSemana').value,
                VISTORIA: Metadata.getInstance<Select>('selectCriarVistoria').value,
                OBSERVACOES: Metadata.getInstance<Select>('selectObservacoesObrigatorias').value,
                EXECUTORHORA: dados,
                SWITCHFUNCIONARIO: 'null',
                NRSEQCONTRATO: Metadata.getInstance<SelectMultiple>('NRSEQCONTRATO').value,
            }).then(() => {
                Utilities.showSuccessMessage();
                this.fecharModalTarefas();
                grid.datasource.get();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public pausarTarefaRecorrente() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        LoadingService.show('Pausando...');

        Http.post('/tarefasRecorrentes', {
            TIPO: 'PAUSAR',
            NRTAREFARECORRENTE: this.linhaClicada.NRTAREFARECORRENTE,
            DATAINICIAL: Metadata.getInstance<ZdDate>('dataInicio').value,
            DATAFINAL: Metadata.getInstance<ZdDate>('dataFinal').value,
        }).then(() => {
            Utilities.showSuccessMessage();
            this.fecharModalPause();
            grid.datasource.get();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public editarTarefasRecorrentes() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        LoadingService.show();

        Http.post('/tarefasRecorrentes', {
            TIPO: 'EDITAR',
            NRTAREFARECORRENTE: this.linhaClicada.NRTAREFARECORRENTE,
            HORARIO: Metadata.getInstance<Time>('selectHoraInicio1').value,
            DURACAO: Metadata.getInstance<TextInput>('selectTempoMedio1').value,
            DIASSEMANA: Metadata.getInstance<SelectMultiple>('selectDiaSemana').value,
            CDOPERTAREFA: Metadata.getInstance<Select>('selectFuncionario').value,
            CDOPERVISTORIA: Metadata.getInstance<Select>('selectEncarregado').value,
        }).then(() => {
            Utilities.showSuccessMessage();
            this.fecharModalEdicao();
            grid.datasource.get();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public cancelarRecorrencia() {
        const component = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        LoadingService.show();

        Http.post('/inativarTarefasRecorrentes', {
            NRS: component.selectedRows.map((element: any) => element.NRTAREFARECORRENTE),
            DATAINICIO: Metadata.getInstance<ZdDate>('dataInicio').value,
        }).then(() => {
            component.datasource.get();
            Utilities.showSuccessMessage();
            this.fecharModalCancelamento();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            component.selectedRows = [];
            LoadingService.hide();
            DialogService.hide();
        });
    }

    public iniciarTarefasRecorrentes() {
        const form = Metadata.getInstance<Form>('formPlayTarefa');
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        if (form.validate()) {
            LoadingService.show();

            Http.post('/recriarTarefasRecorrentes', {
                NRTAREFARECORRENTE: this.linhaClicada.NRTAREFARECORRENTE,
                DATAINICIAL: Metadata.getInstance<ZdDate>('dataInicio').value,
            }).then(() => {
                Utilities.showSuccessMessage();
                this.fecharModalPlay();
                grid.datasource.get();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
                DialogService.hide();
            });
        }
    }

    /* ========== Controle dos modais e ROWCLICK do grid ========== */
       public rowClickGrid({ row }: any) {
        this.linhaClicada = row;
        this.rowClickFunction(row);
    }

    public rowClickFunction(row: any) {
        this.clicks += 1;
        setTimeout(() => {
            if (this.clicks === 1) {
                this.modalPlayPause(row);
            } else if (this.clicks === 2 && row.NMIDSITUACAO !== 'Cancelada') {
                this.exibirModalEdicao();
            }
            this.clicks = 0;
            this.botaoPlayPause = false;
        }, 1000);
    }

    public pausarRecorrencia() {
        const form = Metadata.getInstance<Form>('formPlayPause');
        if (form.validate()) {
            if (!form.value.DataFinal) {
                this.pausarTarefaRecorrente();
            } else {
                this.pausarTarefaRecorrente();
            }
        } else {
            console.log('Preencher campos obrigatorios (*)', 'error');
        }
    }

    // ========== Funções auxiliares ==========
    public async inicializarRecorrencia() {
        this.controlePlayPause = false;
    }

    public inativarTarefas({ event }: any) {
        event?.preventDefault();
        this.exibirModalCancelamento();
    }

    public mudaCor({ row }: any) {
        if (row.NMIDSITUACAO === 'Em Andamento') {
            return { 'color': '#85AB2C' };
        } else if (row.NMIDSITUACAO === 'Pausada') {
            return { 'color': '#5F96D1' };
        } else if (row.NMIDSITUACAO === 'Cancelada') {
            return { 'color': '#999999' };
        }
    }
}
